@charset "utf-8";
@import 'normalize';
@import 'variables';
@import 'icon-font';

@media (min-width: $phone-width) {
  @import 'rtl';
}// uncomment to switch to RTL format


////////////////////////////////////////////////////////////////////////////////
// GENERAL STUFF
////////////////////////////////////////////////////////////////////////////////

html, body {
  color: $main-text;
  padding: 0;
  margin: 0;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  @extend %default-font;
  background-color: $main-bg;
  height: 100%;
  -webkit-text-size-adjust: none; /* Never autoresize text */
}

////////////////////////////////////////////////////////////////////////////////
// TABLE OF CONTENTS
////////////////////////////////////////////////////////////////////////////////

#toc > ul > li > a > span {
  float: right;
  background-color: #2484FF;
  border-radius: 40px;
  width: 20px;
}

.toc-wrapper {
  transition: left 0.3s ease-in-out;

  overflow-y: auto;
  overflow-x: hidden;
  position: fixed;
  z-index: 80;
  top: 0;
  left: 0;
  bottom: 0;
  width: $nav-width;
  background-color: $nav-bg;
  font-size: 13px;
  font-weight: bold;

  // language selector for mobile devices
  .lang-selector {
    display: none;
    a {
      padding-top: 0.5em;
      padding-bottom: 0.5em;
    }
  }

  // This is the logo at the top of the ToC
  .logo {
    display: block;
    max-width: 55%;
    margin-top: $logo-margin - 10%;
    margin-right: $logo-margin - 10%;
    margin-bottom: $logo-margin - 5%;
  }

  &>.search {
    position: relative;
    margin: 30px 0px;
    display: none;
    input {
      border: none;
      background: #eee8db;
      padding: 5px 0 3px 20px;
      box-sizing: border-box;
      height: 35px;
      margin: $nav-v-padding $nav-padding;
      width: $nav-width - ($nav-padding*2) + 1vw;
      outline: none;
      direction: rtl;
      color: $nav-text;
      border-radius: 7px; /* ios has a default border radius */
    }

    &:before {
      position: absolute;
      top: 22px;
      left: $nav-padding;
      color: $nav-text;
      @extend %icon-search;
    }
  }

  .search-results {
    margin-top: 0;
    box-sizing: border-box;
    height: 0;
    overflow-y: auto;
    overflow-x: hidden;
    transition-property: height, margin;
    transition-duration: 180ms;
    transition-timing-function: ease-in-out;
    background: $nav-subitem-bg;
    &.visible {
      height: 30%;
      margin-bottom: 1em;
    }

    li {
      margin: 1em $nav-padding;
      line-height: 1;
    }

    a {
      color: $nav-text;
      text-decoration: none;

      &:hover {
        text-decoration: underline;
      }
    }
  }


  // The Table of Contents is composed of multiple nested
  // unordered lists.  These styles remove the default
  // styling of an unordered list because it is ugly.
  ul, li {
    list-style: none;
    margin: 0;
    text-align: justify;
    padding: 0;
    line-height: 30px;
  }

  li {
    color: $nav-text;
  }

  // This is the currently selected ToC entry

  .toc-link.active {
    background-color: #FF6200;
    border-radius: 5px 0 0 5px;
    color: $nav-active-text;
  }

  .toc-link{
    border-radius: 5px 0 0 5px;
    height: 37px;
    font-size: 13px;
  }

  @media (max-width: $phone-width) {
    
    .toc-link{
      text-align: right;
      padding-right: 0;
    }
  }

  // this is parent links of the currently selected ToC entry
  .toc-link.active-parent {
    background-color: $nav-active-parent-bg;
    color: $nav-active-parent-text;
  }

  .toc-list-h2 {
    display: none;
    background-color: $nav-subitem-bg;
    font-weight: 500;
  }

  .toc-h2 {
    padding-left: $nav-padding + $nav-indent;
    font-size: 12px;
    width: 65%;
    border-radius: 10px 0 0 10px;
  }

  .toc-footer {
    padding: 1em 0;
    margin-top: 1em;
    border-top: 1px dashed $nav-footer-border-color;

    li,a {
      color: $nav-text;
      text-decoration: none;
    }

    a:hover {
      text-decoration: underline;
    }

    li {
      font-size: 0.8em;
      line-height: 1.7;
      text-decoration: none;
    }
  }
}

.toc-link, .toc-footer li {
  padding: 0 $nav-padding 0 $nav-padding;
  display: block;
  overflow-x: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
  text-decoration: none;
  color: $nav-text;
}

// button to show navigation on mobile devices
#nav-button {
  span {
    display: block;
    $side-pad: $main-padding / 2 - 8px;
    padding: $side-pad $side-pad $side-pad;
    background-color: rgba(#fc722a, 0.7);
    transform-origin: 0 0;
    transform: rotate(-90deg) translate(-100%, 0);
    border-radius: 5px 0 0 0;
  } // increase touch size area
  display: none;
  position: fixed;
  left: 92vw;
  height: fit-content;
  width: fit-content;
  z-index: 100;
  color: #000;
  text-decoration: none;
  font-weight: bold;
  opacity: 0.7;
  line-height: 16px;
  img {
    height: 5vw;
    width: auto;
    vertical-align: bottom;
  }

  transition: left 0.3s ease-in-out;

  &:hover { opacity: 1; }
  &.open {left: 27vw}
}


////////////////////////////////////////////////////////////////////////////////
// PAGE LAYOUT AND CODE SAMPLE BACKGROUND
////////////////////////////////////////////////////////////////////////////////

.page-wrapper {
  margin-left: $nav-width;
  position: relative;
  z-index: 10;
  background-color: $main-bg;
  min-height: 100%;

  padding-bottom: 1px; // prevent margin overflow

  // The dark box is what gives the code samples their dark background.
  // It sits essentially under the actual content block, which has a
  // transparent background.
  // I know, it's hackish, but it's the simplist way to make the left
  // half of the content always this background color.
  .dark-box {
    width: $examples-width;
    background-color: $examples-bg;
    position: absolute;
    right: 0;
    top: 0;
    bottom: 0;
  }

  .lang-selector {
    position: fixed;
    z-index: 50;
    background-color: white;
    a{
      padding-left: 11px;
      padding-right: 11px;
      background-color: $side-theme-color;
    }
  }
}

.lang-selector {
  display: flex;
  flex-direction: row-reverse;
  justify-content: flex-start;
  align-items: flex-start;
  background-color: $lang-select-bg;
  width: 100%;
  font-weight: bold;
  box-sizing: border-box;
  padding-top: 15px;
  overflow-x: hidden;
  a {
    display: block;
    color: $lang-select-text;
    text-decoration: none;
    padding: 0 10px;
    line-height: 30px;
    outline: 0;

    &:active, &:focus {
      background-color: $lang-select-pressed-bg;
      color: $lang-select-pressed-text;
    }

    &.active {
      background-color: $lang-select-active-bg;
      color: $lang-select-active-text;
    }
  }

  &:after {
    content: '';
    clear: both;
    display: block;
  }
}

////////////////////////////////////////////////////////////////////////////////
// CONTENT STYLES
////////////////////////////////////////////////////////////////////////////////
// This is all the stuff with the light background in the left half of the page

.content {
  // fixes webkit rendering bug for some: see #538
  -webkit-transform: translateZ(0);
  // to place content above the dark box
  position: relative;
  z-index: 30;

  &:after {
    content: '';
    display: block;
    clear: both;
  }

  &>h1, &>h2, &>h3, &>h4, &>h5, &>h6, &>p, &>table, &>ul, &>ol, &>aside, &>dl {
    margin-right: $examples-width;
    padding: 0 $main-padding;
    box-sizing: border-box;
    display: block;

    @extend %left-col;
  }

  &>ul, &>ol {
    padding-left: $main-padding + 15px;
  }

  // the div is the tocify hidden div for placeholding stuff
  &>h1, &>h2, &>div {
    clear:both;
  }

  h1 {
    @extend %header-font;
    font-size: 30px;
    padding-top: 1.5em;
    padding-bottom: 0.5em;
    margin-bottom: $h1-margin-bottom;
    margin-top: 2em;
    border-top: 1px rgba(168, 168, 168, 0.493) solid;
    background-color: #ffffff;
  }

  h1:first-child, div:first-child + h1 {
    border-top-width: 0;
    margin-top: 0;
  }

  h2 {
    @extend %header-font;
    font-size: 19px;
    margin-top: 4em;
    margin-bottom: 0;
    border-top: 1px solid #ccc;
    padding-top: 1.2em;
    padding-bottom: 1.2em;
    background-image: linear-gradient(to bottom, rgba(#fff, 0.2), rgba(#fff, 0));
  }

  // h2s right after h1s should bump right up
  // against the h1s.
  h1 + h2, h1 + div + h2 {
    margin-top: $h1-margin-bottom * -1;
    border-top: none;
  }

  h3, h4, h5, h6 {
    @extend %header-font;
    font-size: 15px;
    margin-top: 2.5em;
    margin-bottom: 0.8em;
  }

  h4, h5, h6 {
    font-size: 10px;
  }

  hr {
    margin: 2em 0;
    border-top: 2px solid $examples-bg;
    border-bottom: 2px solid $main-bg;
  }

  table {
    margin-bottom: 1em;
    overflow: auto;
    th,td {
      vertical-align: top;
      line-height: 1.6;
      code {
        white-space: nowrap;
      }
    }

    th {
      padding: 5px 10px;
      border-bottom: 1px solid #ccc;
      vertical-align: bottom;
    }

    td {
      padding: 10px;
    }

    tr:last-child {
      border-bottom: 1px solid #ccc;
    }

    tr:nth-child(odd)>td {
      background-color: lighten($main-bg,4.2%);
    }

    tr:nth-child(even)>td {
      background-color: lighten($main-bg,2.4%);
    }
  }

  dt {
    font-weight: bold;
  }

  dd {
    margin-left: 15px;
  }

  p, li, dt, dd {
    line-height: 1.6;
    margin-top: 0;
  }

  img {
    max-width: 100%;
  }

  code {
    background-color: #1E2224;
    padding: 3px;
    color: white;
    border-radius: 3px;
    @extend %break-words;
    @extend %code-font;
  }

  pre>code {
    background-color: transparent;
    padding: 0;
  }

  aside {
    padding-top: 1em;
    padding-bottom: 1em;
    margin-top: 1.5em;
    margin-bottom: 1.5em;
    background: $aside-notice-bg;
    line-height: 1.6;

    &.warning {
      background-color: $aside-warning-bg;
    }

    &.success {
      background-color: $aside-success-bg;
    }
  }

  aside:before {
    vertical-align: middle;
    padding-right: 0.5em;
    font-size: 14px;
  }

  aside.notice:before {
    @extend %icon-info-sign;
  }

  aside.warning:before {
    @extend %icon-exclamation-sign;
  }

  aside.success:before {
    @extend %icon-ok-sign;
  }

  .search-highlight {
    padding: 2px;
    margin: -3px;
    border-radius: 4px;
    border: 1px solid #F7E633;
    background: linear-gradient(to top left, #F7E633 0%, #F1D32F 100%);
  }
}

////////////////////////////////////////////////////////////////////////////////
// CODE SAMPLE STYLES
////////////////////////////////////////////////////////////////////////////////
// This is all the stuff that appears in the right half of the page

.content {
  
  &>div.highlight {
    clear:none;
  }

  pre, blockquote {
    background-color: $code-bg;
    color: #fff;
    margin: 0;
    width: $examples-width;

    float:right;
    clear:right;

    box-sizing: border-box;

    @extend %right-col;

    &>p { margin: 0; }

    a {
      color: #fff;
      text-decoration: none;
      border-bottom: dashed 1px #ccc;
    }
  }


  blockquote {
    border-top-left-radius: 10px;
    border-top-right-radius: 10px;
    width: $examples-width - 2%;
    margin-left: 1%;
  }

  pre{
    @extend %code-font;
    padding-top: 2em;
    padding-bottom: 2em;
    padding: 2em $main-padding;
    max-height: 50000px;
  }

  blockquote {
    &>p {
      background-color: #191D1F;
      padding: $code-annotation-padding 2em;
      color: #eee;
      border-top-left-radius: 10px;
      border-top-right-radius: 10px;
    }
  }
}

////////////////////////////////////////////////////////////////////////////////
// RESPONSIVE DESIGN
////////////////////////////////////////////////////////////////////////////////
// These are the styles for phones and tablets
// There are also a couple styles disperesed

@media (max-width: $tablet-width) {
  
  .toc-wrapper {
    left: 100vw;
    width: $nav-width + 51vw;

    &.open {
      left: 35vw;
    }
  }

  .page-wrapper {
    margin-left: 0;
  }

  #nav-button {
    display: block;
  }

  .toc-link {
    padding-top: 0.3em;
    padding-bottom: 0.3em;
  }
}

@media (max-width: $phone-width) {
  .dark-box {
    display: none;
  }

  %left-col {
    margin-right: 0;
  }

  .toc-wrapper .lang-selector {
    display: block;
    margin-top: 40px;
    margin-bottom: 40px;
  }

  .page-wrapper .lang-selector {
    display: none;
  }

  %right-col {
    width: auto;
    float: none;
  }

  %right-col + %left-col {
    margin-top: $main-padding;
  }

  p,h1,th{
    direction: rtl;
  }
}

.highlight .c, .highlight .cm, .highlight .c1, .highlight .cs {
  color: #909090;
}

.highlight, .highlight .w {
  background-color: $code-bg;
}

.copy-clipboard {
  float: right;
  fill: #9DAAB6;
  cursor: pointer;
  position: fixed;
  opacity: 0.4;
  height: 18px;
  width: 18px;
}

.copy-clipboard:hover {
  opacity: 0.8;
}


/* width */
::-webkit-scrollbar {
  width: 15px;
  height: 15px;
}

/* Track */
::-webkit-scrollbar-track {
  box-shadow: inset 10 10 10px white;
  background: white;
}

/* Handle */
::-webkit-scrollbar-thumb {
  background: #C4C4C4;
  border-radius: 25px;
  border: 4px solid rgba(0, 0, 0, 0);
  background-clip: padding-box;
}

/* Handle on hover */
::-webkit-scrollbar-thumb:hover {
  background: #fc742ad5;
  border: 4px solid rgba(0, 0, 0, 0);
  background-clip: padding-box;
}


h1{
  color: #fc742ad5;
  background-color: white;
}

p{
  border: none;
}

@media (min-width: $phone-width) {

  .copy-clipboard {
    margin-left: 32vw;
  }

  .content {
    pre{
      max-width: $examples-width - 2%;
      margin-left: 1%;
      border-bottom-right-radius: 10px;
      border-bottom-left-radius: 10px;
      margin-bottom: 20px;
    }
  }
}


@media (max-width: $phone-width) {
  .content {
    pre{
      margin-left: 1%;
      border-bottom-right-radius: 10px;
      border-bottom-left-radius: 10px;
      margin-bottom: 20px;
    }
  }
}

@media (max-width: $phone-width + 300px) {
  .copy-clipboard {
    margin-left: 35%;
  }
}

@media (max-width: $phone-width) {
  .copy-clipboard {
    margin-left: 70%;
  }
}

.dark-box {
  background-color: white;
  .lang-selector {
    a {
      background-color: white;
  
      &:active, &:focus {
        background-color: $lang-select-pressed-bg;
        color: $lang-select-pressed-text;
      }
  
      &.active {
        background-color: $lang-select-active-bg;
        color: $lang-select-active-text;
      }
    }
  }
}

@font-face {
  font-family: IRANYekan;
  src: url(../fonts/IRANYekan.ttf);
}

@font-face {
  font-family: VazirCode;
  src: url(../fonts/VazirCode.ttf);
}

p,a,h1{
  font-family: IRANYekan;
}

.content {
    dl{
    padding: 20px;
    background-color: #F6F6F6;
    border-radius: 5px;
    margin-left: 47.5%;
    width: 50%;
    margin-top: 0;
  }

  dl > dl{
    margin-left: 0;
  }
}

html {
  scroll-behavior: smooth;
}

summary {
  background-color: #fd8b4e;
  width: 5vw;
  border-radius: 5px;
  text-align: center;
}

details{
  p{
    border-radius: 5px;
    text-align: center;
    width: 10vw;
    background-color: rgb(90, 235, 227);
  }
  
  p + p {
    border-radius: 5px;
    text-align: center;
    width: 10vw;
    background-color: wheat;
  }
}

summary:hover{
  cursor: pointer;
  transform: scale(1.1);
  background-color: #faa578;
}

summary:active{
  transform: scale(0.9);
}


li {
  width: 93%;
}

.page-wrapper {
  h2{
    text-align: right;
  }
}

@media (max-width: $phone-width) {
    .content {
      dl {
      padding: 20px;
      background-color: #F6F6F6;
      border-radius: 5px;
      margin-left: 2.5%;
      width: 95%;
    }

    blockquote {
      width: 93%;
      margin-left: 3%;
    }
  }

    li {
      float: right;
      li {
        text-align: right;
        float: right;
        direction: rtl;
        width: 100%;
      }
    }

  div.highlight + p{
    float: left;
  }

  div.highlight + p + dl {
    margin-top: 70px;
  }

  div.highlight {
    width: 93%;
    margin-left: 3%;
  }

  blockquote {
    width: 93%;
    margin-left: 2%;
  }

  ul{
    text-align: center;
  }

  .lang-selector{
    a{
      text-align: center;
    }
  }

  .logo{
    width: 75%;
    margin-left: 20%;
    margin-right: 0;
  }
}


.content {

  h1 {
    font-size: 30px;
  }

  dl {
    span > span{
      display: flex;
      justify-content: space-around;
      align-items: flex-start;
      flex-direction: column;
      margin-left: 50px;
      padding: 3px;
    }
    span {
      color: white;
      padding: 3px;
      margin-top: 5px;
      :nth-child(2n - 1) {
        width: fit-content;
        border-radius: 2px;
        color: white;
        background-color: #00A693;
      }
      :nth-child(2n) {
        color: rgba(0, 0, 0, 0.753);
        position: absolute;
        margin-left: 200px;
        margin-top: -25px;
      }
    }
  }
}

.lang-selector {
  font-size: 13px;
  font-weight: bold;
}

blockquote {
  text-align: left;
}


.content {
  h1 {
    font-family: IRANYekan;
  }
  h2 {
    font-family: IRANYekan;
  }
}


a.toc-h2.toc-link {
  width: 100%;
  padding-top: 5px;
}

a.toc-h1.toc-link {
  width: 100%;
  padding-top: 5px;
}

a.toc-h2.toc-link.active {
  width: 75%;
}
